import sys
from PySide6 import QtGui, QtWidgets, QtCore # Import potrebnych modulov Qt (prvky UI /tlacitka, posuvniky, .../ )
from MainWindow_ui import Ui_MainWindow      # Import modulu okna vytvoreneho designerom a skompilovaneho do Ui_MainWIndow.py


class PyQtWindow(QtWidgets.QMainWindow): # Definovanie vlastnej triedy odvodenej od QMainWindow
    def __init__(self):              # Inicializacia okna 
        super().__init__()           # Spustenie inicializacie "rodicovskej" triedy
        self.ui = Ui_MainWindow()    # Vytvorenie objektu okna, ktore je definovane v Ui_MainWindow.py (MainWindow.ui)
        self.ui.setupUi(self)        # Nastavenie prvkov v objekte okna
        self.ui.label.setMinimumSize(400, 200) # Nastavenie minimalnej velkosti widgetu label, do ktoreho sa bude kreslit

    def paintEvent(self, event):     # Metoda, ktora sa spusti pri kazdom prekresleni okna
        w = self.ui.label.width()    # Zistenie sirky okna widgetu Label
        h = self.ui.label.height()   # Zistenie vysky okna widgetu Label
        pixmap = QtGui.QPixmap(w, h) # Vytvorenie pixmapy s rozmermi widgetu Label
        pixmap.fill(QtGui.QColor("transparent")) # Vyplnenie pixmapy priesvitnym pozadim

        painter = QtGui.QPainter() # Vytvorenie kresliaceho objektu
        painter.begin(pixmap)      # Painter bude kreslit do pixmapy 
        # Tu pridu prikazy na kreslenie
        painter.drawRect(0, 0, w-1, h-1), painter.drawLine(0, 0, w-1, h-1)
        self.ui.label.setPixmap(pixmap)  # Widget Label bude pouzivat pixmapu
        painter.end()                    # Koniec kreslenia

if __name__ == '__main__':          # Test, ci som v hlavnom subore (a nie v module)
    app = QtWidgets.QApplication(sys.argv) # Vytvorenie/spustenie nasej aplikacie
    my_form = PyQtWindow()          # Vytvorenie objektu nasho okna, s nami definovanymi metodami (paintEvent, ...)
    my_form.show()                  # Zobrazenie nasho okna, ktore ostava otvorene, az pokym ho nezrusime
    sys.exit(app.exec_())           # Korektne ukoncenie nasej aplikacie
